Scriptname GAttention extends GGoals

float[] Property stimuliTolerance Auto ;; [0, 1]

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; Function: isImportantStimuli
;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; This function takes a stimuli and how much (as a percentage) the NPC perceives or observes that stimuli. This becomes more relevant when an
;; NPC is observed with items that are from different stimuli groups. A lower stimuli tolerance means that an NPC will perceive another NPC as 
;; relevant with fewer elements from a tag group.
;; ---------------------------------------------------------------------------------------------------------------------------------------------
int Function isImportantStimuli(string stim, float observed)
	int i = FindStimuliIndex(stim)
	if (i > -1)
		if (observed < stimuliTolerance[i])
			i = -1
		endif
	endif
	
	return i
EndFunction