Scriptname GBehaviourRegulation extends Alias

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; These properties are setup such that they can be referenced in the NPC editor in the Creation Kit. This allows us to
;; be able to set conditions on AI packages using these values.
;; ---------------------------------------------------------------------------------------------------------------------------------------------
ObjectReference Property vessel Auto
GBehaviourRegulationObject brObj

Event OnInit()
	brObj = (vessel as GBehaviourRegulationObject)
	
	return
EndEvent

Function SetActorEnergy(Actor doe, float intensity)
	doe.SetActorValue("Energy", intensity)
	
	return
EndFunction

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; Function: SetEmotions
;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; This function takes in boolean values representing an emotional state and changes the values of the emotion flags.
;; There are two function types. The first, SetEmotions, requires a flag for all the emotions simultaneously. The second type sets different 
;; emotion flags individually.
;; ---------------------------------------------------------------------------------------------------------------------------------------------
Function SetEmotions (bool isHappy, bool isSad, bool isTrusting, bool isDisgusted, bool isAngry, bool isAfraid, bool isAccepting, bool isSurprised)
	brObj.SetEmotions(isHappy, isSad, isTrusting, isDisgusted, isAngry, isAfraid, isAccepting, isSurprised)
	
	return
EndFunction

Function SetJoy(bool isHappy)
	brObj.SetJoy(isHappy)
	
	;;Debug.Notification("Joy flag set to " + Joy)
	
	return
EndFunction

Function SetSadness(bool isSad)
	brObj.SetSadness(isSad)
	
	;;Debug.Notification("Sadness flag set to " + Sadness)
	
	return
EndFunction

Function SetTrust(bool isTrusting)
	brObj.SetTrust(isTrusting)

	;;Debug.Notification("Trust flag set to " + Trust)
	
	return
EndFunction

Function SetDisgust(bool isDisgusted)
	brObj.SetDisgust(isDisgusted)

	;;Debug.Notification("Disgust flag set to " + Disgust)
	
	return
EndFunction

Function SetFear(bool isAfraid)
	brObj.SetFear(isAfraid)

	;;Debug.Notification("Fear flag set to " + Fear)
	
	return
EndFunction

Function SetAnger(bool isAngry)
	brObj.SetAnger(isAngry)
	
	;;Debug.Notification("Anger flag set to " + Anger)
	
	return
EndFunction

Function SetAcceptance(bool isAccepting)
	brObj.SetAcceptance(isAccepting)

	;;Debug.Notification("Acceptance flag set to " + Acceptance)
	
	return
EndFunction

Function SetSurprise(bool isSurprised)
	brObj.SetSurprise(isSurprised)

	;;Debug.Notification("Surprise flag set to " + Surprise)
	
	return
EndFunction