Scriptname GBehaviourRegulationObject extends ObjectReference Conditional

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; These properties are setup such that they can be referenced in the NPC editor in the Creation Kit. This allows us to
;; be able to set conditions on AI packages using these values.
;; ---------------------------------------------------------------------------------------------------------------------------------------------
Int Property Joy = 0 Auto Conditional
Int Property Sadness = 0 Auto Conditional
Int Property Trust = 0 Auto Conditional
Int Property Disgust = 0 Auto Conditional
Int Property Fear = 0 Auto Conditional
Int Property Anger = 0 Auto Conditional
Int Property Acceptance = 0 Auto Conditional
Int Property Surprise = 0 Auto Conditional

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; Function: SetEmotions
;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; This function takes in boolean values representing an emotional state and changes the values of the emotion flags.
;; There are two function types. The first, SetEmotions, requires a flag for all the emotions simultaneously. The second type sets different 
;; emotion flags individually.
;; ---------------------------------------------------------------------------------------------------------------------------------------------
Function SetEmotions (bool isHappy, bool isSad, bool isTrusting, bool isDisgusted, bool isAngry, bool isAfraid, bool isAccepting, bool isSurprised)
	SetJoy(isHappy)
	SetSadness(isSad)
	SetTrust(isTrusting)
	SetDisgust(isDisgusted)
	SetFear(isAfraid)
	SetAnger(isAngry)
	SetAcceptance(isAccepting)
	SetSurprise(isSurprised)
	
	return
EndFunction

Function SetJoy(bool isHappy)
	if (isHappy)
		Joy = 1
	else
		Joy = 0
	endif
	
	;;Debug.Notification("Joy flag set to " + Joy)
	
	return
EndFunction

Function SetSadness(bool isSad)
	if (isSad)
		Sadness = 1
	else
		Sadness = 0
	endif
	
	;;Debug.Notification("Sadness flag set to " + Sadness)
	
	return
EndFunction

Function SetTrust(bool isTrusting)
	if (isTrusting)
		Trust = 1
	else
		Trust = 0
	endif

	;;Debug.Notification("Trust flag set to " + Trust)
	
	return
EndFunction

Function SetDisgust(bool isDisgusted)
	if (isDisgusted)
		Disgust = 1
	else
		Disgust = 0
	endif

	;;Debug.Notification("Disgust flag set to " + Disgust)
	
	return
EndFunction

Function SetFear(bool isAfraid)
	if (isAfraid)
		Fear = 1
	else
		Fear = 0
	endif

	;;Debug.Notification("Fear flag set to " + Fear)
	
	return
EndFunction

Function SetAnger(bool isAngry)
	if (isAngry)
		Anger = 1
	else
		Anger = 0
	endif
	
	;;Debug.Notification("Anger flag set to " + Anger)
	
	return
EndFunction

Function SetAcceptance(bool isAccepting)
	if (isAccepting)
		Acceptance = 1
	else
		Acceptance = 0
	endif

	;;Debug.Notification("Acceptance flag set to " + Acceptance)
	
	return
EndFunction

Function SetSurprise(bool isSurprised)
	if (isSurprised)
		Surprise = 1
	else
		Surprise = 0
	endif

	;;Debug.Notification("Surprise flag set to " + Surprise)
	
	return
EndFunction