Scriptname GEmotionDecay extends Alias

int Property eqJoy = 50 Auto
;int eqSadness = 50
int Property eqTrust = 50 Auto
;int eqDisgust = 50
int Property eqFear = 50 Auto
;int eqAnger = 50
int Property eqAnticipation = 50 Auto
;int eqSurprise = 50

int Property decayStep = 1 Auto
float Property decaySpeedInSeconds = 2.0 Auto

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; Function: DecayEmotions
;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; This function takes in the current emotion values and determines which direction (+/-) that they need to move in to return to the designated 
;; equilibrium values (eqJoy, eqTrust, eqFear, eqAnticipation).
;; ---------------------------------------------------------------------------------------------------------------------------------------------
int[] function DecayEmotions(int j, int sad, int t, int d, int ang, int f, int ant, int sur)
	int[] em = new int [8]
	
	if (j != eqJoy)
		if (j > sad)
			em[0] = - decayStep
		else
			em[0] = decayStep
		endif
	endif
	em[1] = -1 * em[0]
	
	if (t != eqTrust)
		if (t > d)
			em[2] = - decayStep
		else
			em[2] = decayStep
		endif
	endif
	em[3] = -1 * em[2]
	
	if (f != eqFear)
		if (f > ang)
			em[4] = - decayStep
		else
			em[4] = decayStep
		endif
	endif
	em[5] = -1 * em[4]
	
	if (ant != eqAnticipation)
		if (ant > sur)
			em[6] = - decayStep
		else
			em[6] = decayStep
		endif
	endif
	em[7] = -1 * em[6]
	
	return em
endfunction

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; Get Functions
;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; These functions are used to retrieve the equilibrium values and decay rate for this NPC. 
;; ---------------------------------------------------------------------------------------------------------------------------------------------
int Function GetEquilibriumJoy()
	return eqJoy
EndFunction

int Function GetEquilibriumTrust()
	return eqTrust
EndFunction

int Function GetEquilibriumFear()
	return eqFear
EndFunction

int Function GetEquilibriumAnticipation()
	return eqAnticipation
EndFunction

float Function GetDecayRate()
	return decaySpeedInSeconds
EndFunction