Scriptname GExpressiveCommunication extends Alias

Idle Property stopIdle Auto
Idle Property joyIdle Auto
Idle Property sadIdle Auto
Idle Property trustIdle Auto
Idle Property disgustIdle Auto
Idle Property fearIdle Auto
Idle Property angerIdle Auto
Idle Property acceptIdle Auto
Idle Property surpriseIdle Auto

;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; Express Functions
;; ---------------------------------------------------------------------------------------------------------------------------------------------
;; These functions allow us to manually run animations on an NPC depending on their emotional state. In this case, we are overriding their 
;; facial animation using a Creation Kit function "SetExpressionOverride".
;; ---------------------------------------------------------------------------------------------------------------------------------------------

Function ExpressJoy(Actor doe, int strength, bool playAnim)
	;;Debug.Notification("[" + doe.GetBaseObject().GetName() + "] ExpressJoy Function called")
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(joyIdle)
	endif

	doe.SetExpressionOverride(10, strength)
	
	return
EndFunction

Function ExpressSadness(Actor doe, int strength, bool playAnim)
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(sadIdle)
	endif
	
	doe.SetExpressionOverride(11, strength)
	
	return
EndFunction

Function ExpressTrust(Actor doe, int strength, bool playAnim)
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(trustIdle)
	endif
	
	doe.SetExpressionOverride(7, strength)
	
	return
EndFunction

Function ExpressDisgust(Actor doe, int strength, bool playAnim)
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(disgustIdle)
	endif
	
	doe.SetExpressionOverride(14, strength)
	
	return
EndFunction

Function ExpressFear(Actor doe, int strength, bool playAnim)
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(fearIdle)
	endif
	
	doe.SetExpressionOverride(9, strength)
	
	return
EndFunction

Function ExpressAnger(Actor doe, int strength, bool playAnim)
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(angerIdle)
	endif
	
	doe.SetExpressionOverride(8, strength)
	
	return
EndFunction

Function ExpressAcceptance(Actor doe, int strength, bool playAnim)
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(acceptIdle)
	endif
	
	doe.SetExpressionOverride(7, strength)
	
	return
EndFunction

Function ExpressSurprise(Actor doe, int strength, bool playAnim)
	ClearExpressedEmotion(doe)
	bool playSuccess
	
	if (playAnim)
		playSuccess = doe.PlayIdle(surpriseIdle)
	endif
	
	doe.SetExpressionOverride(12, strength)
	
	return
EndFunction

Function ClearExpressedEmotion(Actor doe)
	doe.ClearExpressionOverride()
	bool playSuccess = doe.PlayIdle(stopIdle)
	
	return
EndFunction